﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Microsoft.VisualStudio.Modeling.Validation;

namespace BatRF.TagParseLanguage
{
    [ValidationState(ValidationState.Enabled)]
    partial class ParseMaster
    {
        [ValidationMethod(ValidationCategories.Load | ValidationCategories.Open | ValidationCategories.Menu)]
        private void CheckForGap(ValidationContext vc)
        {
            
            var decs = from Decoder dec in this.Decoders
                       orderby dec.StartPoint
                       select dec;
            Decoder lastDec = decs.First();
                            
            foreach (Decoder dec in decs)
            {
                if (dec != lastDec &&
                    dec.StartPoint != lastDec.StartPoint + lastDec.Length)
                {
                    vc.LogMessage(dec.DecoderName + "'s start point is after " + lastDec.DecoderName + "'s end point(" + (lastDec.StartPoint + lastDec.Length).ToString() + ")",  "TP001");        
                }
                lastDec = dec;
            }

            if (decs.Last().Length + decs.Last().StartPoint != this.MessageLength)
            {
                vc.LogMessage("A gap exists between the end of " + decs.Last().DecoderName + " and the end of the message", "TP002");        
            }
        }
    }
}
