﻿using BatRF.TagParseLanguage.CodeGeneration;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace Batrf.TagParseLanguage
{
    [ProvideCodeGenerator(typeof(CodeGenerator), "TclFileCodeGenerator",
     "Generates tag parsers", true, ProjectSystem=
                ProvideCodeGeneratorAttribute.CSharpProjectGuid)]
    internal sealed partial class TagParseLanguagePackage
    {
     
    }

    [System.Runtime.InteropServices.Guid("4B041800-E61B-4738-8D92-986152F448A7")]
    public class CodeGenerator : Microsoft.VisualStudio.TextTemplating.VSHost.TemplatedCodeGenerator
    {
        protected override byte[] GenerateCode(string InputFileName, string InputFileContent)
        {
            System.IO.FileInfo fi = new System.IO.FileInfo(InputFileName);
            if (fi.Length < 10)
            {
                return null;
            }
            InputFileContent = System.Text.ASCIIEncoding.UTF8.GetString(TagParseResources.TagParseGenerator);
            InputFileContent = InputFileContent.Replace("%INPUTFILENAME%", InputFileName);
            //InputFileContent = InputFileContent.Replace("%INPUTNAMESPACE%", this.FileNamespace);
            
            byte[] data = base.GenerateCode(InputFileName, InputFileContent);
            byte[] ascii = new byte[data.Length - 3];
            System.Array.Copy(data, 3, ascii, 0, data.Length - 3);
            return ascii;
        }

        static string VSVersion = "9.0";
        static string CSLangGUID = "{fae04ec1-301f-11d3-bf4b-00c04f79efbc}";
        static string GeneratorExtension = ".tpl2";
        static string GeneratorName = "TclFileCodeGenerator";
            
        [System.Runtime.InteropServices.ComRegisterFunction]
        public static void RegisterClass(System.Type typ)
        {
            Microsoft.Win32.RegistryKey key;
            string keyname = @"SOFTWARE\Microsoft\VisualStudio\" + VSVersion +
                             @"\Generators\" + CSLangGUID + @"\" + GeneratorExtension + @"\";
            key = Microsoft.Win32.Registry.LocalMachine.CreateSubKey(keyname);
            key.SetValue("", GeneratorName);
        }

        [System.Runtime.InteropServices.ComUnregisterFunction]
        public static void UnregisterClass(System.Type typ)
        {
            string keyname = @"SOFTWARE\Microsoft\VisualStudio\" + VSVersion +
                             @"\Generators\" + CSLangGUID + @"\" + GeneratorExtension + @"\";
            Microsoft.Win32.Registry.LocalMachine.DeleteSubKey(keyname,false);
        }
    }
}
